name: issuer-revocation-uservice

on:
  workflow_dispatch:
    inputs:
      version:
        description: "Version"
        required: true
        type: string
jobs:
  build-and-push:
    name: Deploy issuer-revocation-uservice

    runs-on: ubuntu-latest
    env:
      APPLICATION_NAME: issuer-revocation
    permissions:
      id-token: write
      contents: write
    steps:
      - name: Checkout
        uses: actions/checkout@v3
        with:
          fetch-depth: 0

      - name: Set up Node.js
        uses: actions/setup-node@v3
        with:
          node-version: "18"
          cache: "yarn"

      - name: Configure AWS credentials
        uses: aws-actions/configure-aws-credentials@v2
        with:
          role-to-assume: arn:aws:iam::960693787136:role/GitHubAction-AssumeRoleWithAction
          aws-region: eu-west-1
          mask-aws-account-id: no

      - name: Login to Amazon ECR
        id: login-ecr
        uses: aws-actions/amazon-ecr-login@v1

      - name: Build, Tag, and Push the Image of ${{env.APPLICATION_NAME}} to Amazon ECR
        id: build-image
        env:
          ECR_REGISTRY: ${{ steps.login-ecr.outputs.registry }}
          ECR_REPOSITORY: esspass
          IMAGE_TAG: esspass/esspass-${{env.APPLICATION_NAME}}:${{ github.event.inputs.version }}
        run: |
          docker buildx build -f ./apps/$APPLICATION_NAME/Dockerfile . -t $IMAGE_TAG --build-arg rev=$(git rev-parse --short HEAD) --build-arg branch=$(git rev-parse --abbrev-ref HEAD)
          docker tag $IMAGE_TAG $ECR_REGISTRY/$ECR_REPOSITORY:esspass-$APPLICATION_NAME-${{ github.event.inputs.version }}
          docker push $ECR_REGISTRY/$ECR_REPOSITORY:esspass-$APPLICATION_NAME-${{ github.event.inputs.version }}

      - name: Configure AWS credentials
        uses: aws-actions/configure-aws-credentials@v2
        with:
          aws-access-key-id: ${{ secrets.AWS_ACCESS_KEY_ID }}
          aws-secret-access-key: ${{ secrets.AWS_SECRET_ACCESS_KEY }}
          aws-region: eu-west-1
          mask-aws-account-id: no

      - name: Install kubectl
        uses: azure/setup-kubectl@v3

      - name: Install Helm
        run: |
          wget https://get.helm.sh/helm-v3.7.0-linux-amd64.tar.gz
          tar -zxvf helm-v3.7.0-linux-amd64.tar.gz
          sudo mv linux-amd64/helm /usr/local/bin/

      - name: Configure Helm
        run: helm repo add stable https://charts.helm.sh/stable

      - name: Install dependencies
        run: helm dependency update ./apps/$APPLICATION_NAME/helm

      - name: Configure EKS cluster credentials
        run: aws eks update-kubeconfig --name dev-esspass-k8s --region eu-west-1

      - name: Get pods in EKS cluster
        run: |
          kubectl config set-context --current --namespace=dev-esspass
          helm list --namespace dev-esspass

      - name: Helm install
        run: helm upgrade --install $APPLICATION_NAME ./apps/$APPLICATION_NAME/helm --set-string image.repository=${{ steps.login-ecr.outputs.registry }}/esspass:esspass-$APPLICATION_NAME-${{ github.event.inputs.version }} --set-string deployment.version=${{ github.event.inputs.version }}
